//Veelsteveel includes
#include "gd.h"
#include "gdhelp.h"
#include "lcd.h"
#include "lcdc.h"
#include <string.h>

int LoadConfig(char* file, config_line *config) {
        FILE *fd;
	char buf[LINEBUFLEN];
	int t=-1;
	fd=fopen(file,"r");
	while (!feof(fd)) {
	    fgets(buf,LINEBUFLEN,fd);
	    if (strlen(buf)>4) {
		buf[strlen(buf)-1]=0; //Eat enter
		printf("Line: %s\n",buf);
		if (strstr(buf,"port")) {
		    size_t tmp;
		    tmp=strlen(strstr(buf,"="))+2;
		    strcpy(parportdev,strstr(buf,"=")+1);
		    printf("Port entry.\n");
		} else if (strstr(buf,"update")) {
		    updatedelay=atoi(strstr(buf,"=")+1);
		} else if (strstr(buf,"firmware")) {
		    size_t tmp;
		    tmp=strlen(strstr(buf,"="))+2;
		    strcpy(firmwarefile,strstr(buf,"=")+1);
		    printf("Firmware-file- entry.\n");
		} else if (strstr(buf,"[image]")) {
		    t++;
		    config[t].X=0;
		    config[t].Y=0;
		    config[t].Type=CFG_IMAGE_DIRECT;
		    printf("Image section found.\n");
		} else if (strstr(buf,"[text]")) {
		    t++;
		    config[t].X=0;
		    config[t].Y=0;
		    config[t].H=100;
		    config[t].W=100;
		    config[t].Color=0;
		    config[t].Font=2;
		    config[t].Type=CFG_TEXT_DIRECT;
		    printf("Text section found.\n");
		} else if (strstr(buf,"xpos")) {
		    config[t].X=atoi(strstr(buf,"=")+1);
		} else if (strstr(buf,"ypos")) {
		    config[t].Y=atoi(strstr(buf,"=")+1);
		} else if (strstr(buf,"height")) {
		    config[t].H=atoi(strstr(buf,"=")+1);
		} else if (strstr(buf,"width")) {
		    config[t].W=atoi(strstr(buf,"=")+1);
		} else if (strstr(buf,"script")) {
		    size_t tmp;
		    tmp=strlen(strstr(buf,"="))+2;
		    config[t].Source=malloc(tmp);
		    strcpy(config[t].Source,strstr(buf,"=")+1);
		    config[t].Type=config[t].Type | 1;
		    printf("Script entry.\n");
		} else if (strstr(buf,"text")) {
		    size_t tmp;
		    tmp=strlen(strstr(buf,"="))+2;
		    config[t].Source=malloc(tmp);
		    strcpy(config[t].Source,strstr(buf,"=")+1);
		    config[t].Type=CFG_TEXT_DIRECT;
		    printf("Direct entry.\n");
		} else if (strstr(buf,"file")) {
		    size_t tmp;
		    tmp=strlen(strstr(buf,"="))+2;
		    config[t].Source=malloc(tmp);
		    strcpy(config[t].Source,strstr(buf,"=")+1);
		    config[t].Type=config[t].Type | 2;
		    printf("File entry.\n");
		}

	    }
	}
	fclose(fd);
	return t;
}

int main(){
    int pport;
    gdImagePtr imgbuff;
    int tmp;
    int maxcfg;
    int x;
    FILE *dump;
    config_line config[MAXCFG];

    strcpy(parportdev,"/dev/parport1");
    strcpy(firmwarefile,"lcdc.mcs");
    maxcfg=LoadConfig("lcdc.conf",config);
    imgbuff=gdImageCreate(640,200);
    gdImageColorAllocate(imgbuff,0,0,0);
    gdImageColorAllocate(imgbuff,255,255,255);
    
    pport=LcdOpen(parportdev,firmwarefile);
    
    while (1) {     
    for (x=0; x<=maxcfg; x++) {
	if (config[x].Type==CFG_TEXT_DIRECT) {
	    DrawText(imgbuff, config[x].Source, config[x].X, config[x].Y, config[x].W, config[x].H);
	    printf("Drawing: %s\n",config[x].Source);
	} else if (config[x].Type==CFG_TEXT_SCRIPT) {
	    FILE *fd;
	    int t;
	    char buff[MAXTXTLEN];
	    strcpy(buff,"");
	    fd=popen(config[x].Source,"r");
	    t=0;
	    while (!feof(fd)) buff[t++]=fgetc(fd);
	    pclose(fd);
	    buff[t]=0;
	    DrawText(imgbuff, buff, config[x].X, config[x].Y, config[x].W, config[x].H);
	    printf("Drawing: %s\n",config[x].Source);
	} else if (config[x].Type==CFG_IMAGE_FILE) {
	    BlitImage(imgbuff, config[x].Source, config[x].X, config[x].Y);
	    printf("Painting: %s\n",config[x].Source);
	}
    }
    LcdLoadPic(pport, imgbuff);
    printf("Finished.\n");
    printf("Sleeping %i secs...\n",updatedelay);
    dump=fopen("scrdump.png","w");
    gdImagePng(imgbuff,dump);
    fclose(dump);
    sleep(updatedelay);
    }
    LcdClose(pport);
    gdImageDestroy(imgbuff);    
}
