--
--  File: C:\FNDTN\ACTIVE\PROJECTS\LCDC1\RequestReg2.vhd
-- created: 03/04/03 13:29:16
--  from: 'C:\FNDTN\ACTIVE\PROJECTS\LCDC1\RequestReg2.asf'
--  by fsm2hdl - version: 2.0.1.49
--
library IEEE;
use IEEE.std_logic_1164.all;

use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library SYNOPSYS;
use SYNOPSYS.attributes.all;

entity requestreg2 is 
  port (Clk: in STD_LOGIC;
        ClrReq: in STD_LOGIC;
        ReqAdIn: in STD_LOGIC_VECTOR (0 to 1);
        ReqClk: in STD_LOGIC;
        ReqDat: in STD_LOGIC_VECTOR (0 to 7);
        ReqAddr: out STD_LOGIC_VECTOR (0 to 14);
        ReqData: out STD_LOGIC_VECTOR (0 to 7);
        ReqValid: out STD_LOGIC);
end;

architecture requestreg2_arch of requestreg2 is

--diagram signal declarations
signal Addr: STD_LOGIC_VECTOR (0 to 14);

-- SYMBOLIC ENCODED state machine: Sreg0
type Sreg0_type is (S1, S2, S3, S5, S6);
signal Sreg0: Sreg0_type;

begin
--concurrent signal assignments
--diagram ACTIONS;


Sreg0_machine: process (Clk)

begin

if Clk'event and Clk = '1' then
	case Sreg0 is
		when S1 =>
			if ReqClk='1' and ReqAdIn="00" then
				Sreg0 <= S2;
			elsif ReqClk='1' and ReqAdIn="01" then
				Sreg0 <= S5;
			elsif ReqClk='1' and ReqAdIn="10" then
				Sreg0 <= S6;
			elsif ReqClk='0' then
				Sreg0 <= S1;
			else
				Sreg0 <= S1;
			end if;
		when S2 =>
			if ClrReq='0' then
				Sreg0 <= S2;
			elsif ClrReq='1' then
				Sreg0 <= S3;
				Addr(7 to 14)<=Addr(7 to 14)+"1";
			else
				Sreg0 <= S1;
			end if;
		when S3 =>
			if ReqClk='1' then
				Sreg0 <= S3;
			elsif ReqClk='0' then
				Sreg0 <= S1;
			else
				Sreg0 <= S1;
			end if;
		when S5 =>
			Addr(7 to 14)<=ReqDat;
			Sreg0 <= S3;
		when S6 =>
			Addr(0 to 6)<=ReqDat(1 to 7);
			Sreg0 <= S3;
		when others =>   -- trap state
			Sreg0 <= S1;
	end case;
end if;
end process;

-- signal assignment statements for combinatorial outputs
ReqData_assignment:
ReqData <= ReqDat when (Sreg0 = S1) else
           ReqDat when (Sreg0 = S2) else
           ReqDat when (Sreg0 = S3) else
           ReqDat;

ReqValid_assignment:
ReqValid <= '0' when (Sreg0 = S1) else
            '1' when (Sreg0 = S2) else
            '0' when (Sreg0 = S2 and ClrReq='1') else
            '0' when (Sreg0 = S3) else
            '0' when (Sreg0 = S5) else
            '0' when (Sreg0 = S6) else
            '0';

ReqAddr_assignment:
ReqAddr <= Addr when (Sreg0 = S1) else
           Addr when (Sreg0 = S2) else
           Addr when (Sreg0 = S2 and ClrReq='1') else
           Addr when (Sreg0 = S3) else
           Addr;

end requestreg2_arch;
