--
--  File: C:\FNDTN\ACTIVE\PROJECTS\LCDC1\StateMachine.vhd
-- created: 03/04/03 13:28:30
--  from: 'C:\FNDTN\ACTIVE\PROJECTS\LCDC1\StateMachine.asf'
--  by fsm2hdl - version: 2.0.1.49
--
library IEEE;
use IEEE.std_logic_1164.all;

use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library SYNOPSYS;
use SYNOPSYS.attributes.all;

entity statemachine is 
  port (Clk: in STD_LOGIC;
        DispAddr: in STD_LOGIC_VECTOR (0 to 14);
        ReqAddr: in STD_LOGIC_VECTOR (0 to 14);
        ReqData: in STD_LOGIC_VECTOR (0 to 7);
        ReqValid: in STD_LOGIC;
        CL2: out STD_LOGIC;
        ClrReq: out STD_LOGIC;
        DispData: out STD_LOGIC_VECTOR (0 to 7);
        EnableNext: out STD_LOGIC;
        RamAddr: out STD_LOGIC_VECTOR (0 to 14);
        RamOE: out STD_LOGIC;
        RamWR: out STD_LOGIC;
        RamData: inout STD_LOGIC_VECTOR (0 to 7));
end;

architecture statemachine_arch of statemachine is


-- SYMBOLIC ENCODED state machine: Sreg2142643912
type Sreg2142643912_type is (S1, S2, S3, S4, S5, S6, S7);
signal Sreg2142643912: Sreg2142643912_type;

begin
--concurrent signal assignments
--diagram ACTIONS;


Sreg2142643912_machine: process (Clk)

begin

if Clk'event and Clk = '1' then
	case Sreg2142643912 is
		when S1 =>
			Sreg2142643912 <= S2;
		when S2 =>
			Sreg2142643912 <= S3;
		when S3 =>
			Sreg2142643912 <= S4;
		when S4 =>
			if ReqValid='1' then
				Sreg2142643912 <= S5;
			elsif ReqValid='0' then
				Sreg2142643912 <= S1;
			end if;
		when S5 =>
			Sreg2142643912 <= S6;
		when S6 =>
			Sreg2142643912 <= S7;
		when S7 =>
			Sreg2142643912 <= S1;
		when others =>
			null;
	end case;
end if;
end process;

-- signal assignment statements for combinatorial outputs
RamWR_assignment:
RamWR <= '1' when (Sreg2142643912 = S1) else
         '1' when (Sreg2142643912 = S2) else
         '1' when (Sreg2142643912 = S3) else
         '1' when (Sreg2142643912 = S4) else
         '1' when (Sreg2142643912 = S5) else
         '0' when (Sreg2142643912 = S6) else
         '1' when (Sreg2142643912 = S7) else
         '1';

RamOE_assignment:
RamOE <= '0' when (Sreg2142643912 = S1) else
         '0' when (Sreg2142643912 = S2) else
         '0' when (Sreg2142643912 = S3) else
         '0' when (Sreg2142643912 = S4) else
         '1' when (Sreg2142643912 = S5) else
         '1' when (Sreg2142643912 = S6) else
         '1' when (Sreg2142643912 = S7) else
         '1';

Cl2_assignment:
Cl2 <= '0' when (Sreg2142643912 = S1) else
       '0' when (Sreg2142643912 = S2) else
       '1' when (Sreg2142643912 = S3) else
       '0' when (Sreg2142643912 = S4) else
       '0' when (Sreg2142643912 = S5) else
       '0' when (Sreg2142643912 = S6) else
       '0' when (Sreg2142643912 = S7) else
       '0';

DispData_assignment:
DispData <= RamData when (Sreg2142643912 = S1) else
            RamData when (Sreg2142643912 = S2) else
            RamData when (Sreg2142643912 = S3) else
            RamData when (Sreg2142643912 = S4) else
            "00000000" when (Sreg2142643912 = S5) else
            "00000000" when (Sreg2142643912 = S6) else
            "00000000" when (Sreg2142643912 = S7) else
            "00000000";

RamAddr_assignment:
RamAddr <= DispAddr when (Sreg2142643912 = S1) else
           DispAddr when (Sreg2142643912 = S2) else
           DispAddr when (Sreg2142643912 = S3) else
           DispAddr when (Sreg2142643912 = S4) else
           ReqAddr when (Sreg2142643912 = S5) else
           ReqAddr when (Sreg2142643912 = S6) else
           ReqAddr when (Sreg2142643912 = S7) else
           ReqAddr;

EnableNext_assignment:
EnableNext <= '0' when (Sreg2142643912 = S1) else
              '0' when (Sreg2142643912 = S2) else
              '0' when (Sreg2142643912 = S3) else
              '1' when (Sreg2142643912 = S4) else
              '0' when (Sreg2142643912 = S5) else
              '0' when (Sreg2142643912 = S6) else
              '0' when (Sreg2142643912 = S7) else
              '0';

ClrReq_assignment:
ClrReq <= '0' when (Sreg2142643912 = S1) else
          '0' when (Sreg2142643912 = S2) else
          '0' when (Sreg2142643912 = S3) else
          '0' when (Sreg2142643912 = S4) else
          '0' when (Sreg2142643912 = S5) else
          '0' when (Sreg2142643912 = S6) else
          '1' when (Sreg2142643912 = S7) else
          '1';

RamData_assignment:
RamData <= "ZZZZZZZZ" when (Sreg2142643912 = S1) else
           "ZZZZZZZZ" when (Sreg2142643912 = S2) else
           "ZZZZZZZZ" when (Sreg2142643912 = S3) else
           "ZZZZZZZZ" when (Sreg2142643912 = S4) else
           ReqData when (Sreg2142643912 = S5) else
           ReqData when (Sreg2142643912 = S6) else
           ReqData when (Sreg2142643912 = S7) else
           ReqData;

end statemachine_arch;
