library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity Lcdc_main is
    port (
        DataH: out STD_LOGIC_VECTOR (0 to 3);
        DataL: out STD_LOGIC_VECTOR (0 to 3);
        Clk: in STD_LOGIC;
--        Reset: in STD_LOGIC;        
        Cl1: out STD_LOGIC;
        Cl2: out STD_LOGIC;
        Din: out STD_LOGIC;
        M: out STD_LOGIC;
        Led: out STD_LOGIC;
        RamA: out STD_LOGIC_VECTOR (0 to 14);
        RamD: inout STD_LOGIC_VECTOR (0 to 7);        
				RamOE: out STD_LOGIC;
				RamCE: out STD_LOGIC;
				RamWE: out STD_LOGIC;
        ReqClk: in STD_LOGIC;				
				ReqAdIn: in STD_LOGIC_VECTOR (0 to 1);
        ReqDat: in STD_LOGIC_VECTOR(0 to 7);
        InvOut: out STD_LOGIC
    );
end Lcdc_main;

architecture Lcdc_main_arch of Lcdc_main is
signal cnt: STD_LOGIC_VECTOR(0 to 20);
begin
	process(clk)
	begin
		if clk'event and clk='1' then
			cnt<=cnt+"1";
		end if;
	end process;
	RamCE<='1';
	DataH<=cnt(0 to 3);
	DataL<=cnt(4 to 7);	
	led<=cnt(0);
	cl1<=ReqAdIn(1);
	cl2<='1';
	din<='1';
	m<=not ReqClk;
	RamA<=cnt(0 to 14);
	RamOE<='1';
	RamWE<=ReqAdIn(1);
	InvOut<=ReqAdIn(0);
	RamD<=not ReqDat;
end Lcdc_main_arch;

--RAM indeling:
--Ram begint op (-1,0). Per byte 4 bits hoog beeld (uitgespreid in Xpos), 4 bits laag beeld.
--Virtuele beeldruimte: 1024X128

--Display-aansturing: Het display is in 2 gedeeltes opgedeeld, elk 104 (???) pixels hoog.
--Data wordt ingeklokt op de op- of neergaande (ben er nog steeds niet achter welke) flank van CL2: de 4 hoogste
--bits gaan naar het bovenste gedeelte van het LCD als 4 pixels naast elkaar, de 4 onderste naar de onderste.
--Cl1 reset de X-positie en zorgt dat het display de volgende lijn pakt.
--Din moet hoog gemaakt worden op het moment dat Cl1 geschopt wqordt voor de eerste lijn.
