library IEEE;
use IEEE.std_logic_1164.all;
--The IEEE standard 1164 package, declares std_logic, rising_edge(), etc.
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity xcount is
    port (
        Enable: in STD_LOGIC;        
        Clk: in STD_LOGIC;
        Reset: in STD_LOGIC;        
				Carry: out STD_LOGIC;        
        Xpos: buffer STD_LOGIC_VECTOR (0 to 7)
    );
end xcount;


--Counter voor de X-positie, met een carry-out om de Y-counter aan te sturen
--Telt van 0 tot (640/4)=160
architecture xcount_arch of xcount is
begin
  process(Clk)
  begin
		if Clk'event and Clk='1' then
			if Enable='1' then
	  		if Reset='0' then
	  			if Xpos="10100000" then    --160
	  				Xpos<="00000000";
	  				Carry<='1';
	  			else
	  				Xpos<=Xpos+"00000001";
	  				Carry<='0';
	  			end if;
	  		else
	  			Xpos<="00000000";
	  			Carry<='0';  			
	  		end if;
	  	end if;
	  end if;
  end process;
end xcount_arch;

